com.typesafe.config

## Interface ConfigObject

All Superinterfaces:
  ConfigMergeable, ConfigValue, java.util.Map<java.lang.String,ConfigValue>

    public interface ConfigObject
    extends ConfigValue, java.util.Map<java.lang.String,ConfigValue>

Subtype of `ConfigValue` representing an object (AKA dictionary or map) value, as in JSON's curly brace `{ "a" : 42 }` syntax.

An object may also be viewed as a `Config` by calling `toConfig()`.

`ConfigObject` implements `java.util.Map<String, ConfigValue>` so you can use it like a regular Java map. Or call `unwrapped()` to unwrap the map to a map with plain Java values rather than `ConfigValue`.

Like all `ConfigValue` subtypes, `ConfigObject` is immutable. This makes it threadsafe and you never have to create "defensive copies." The mutator methods from `Map` all throw `UnsupportedOperationException`.

The `ConfigValue.valueType()` method on an object returns `ConfigValueType.OBJECT`.

In most cases you want to use the `Config` interface rather than this one. Call `toConfig()` to convert a `ConfigObject` to a `Config`.

The API for a `ConfigObject` is in terms of keys, while the API for a `Config` is in terms of path expressions. Conceptually, `ConfigObject` is a tree of maps from keys to values, while a `Config` is a one-level map from paths to values.

Use `ConfigUtil.joinPath(java.lang.String...)` and `ConfigUtil.splitPath(java.lang.String)` to convert between path expressions and individual path elements (keys).

A `ConfigObject` may contain null values, which will have `ConfigValue.valueType()` equal to `ConfigValueType.NULL`. If `get(Object)` returns Java's null then the key was not present in the parsed file (or wherever this value tree came from). If `get("key")` returns a `ConfigValue` with type `ConfigValueType#NULL` then the key was set to null explicitly in the config file.

Do not implement interface `ConfigObject`; it should only be implemented by the config library. Arbitrary implementations will not work because the library internals assume a specific concrete implementation. Also, this interface is likely to grow new methods over time, so third-party implementations will break.

### Nested Class Summary

### Nested classes/interfaces inherited from interface java.util.Map

`java.util.Map.Entry<K,V>`

### Method Summary

All Methods Instance Methods Abstract Methods
`ConfigValue` `get(java.lang.Object key)` Gets a `ConfigValue` at the given key, or returns null if there is no value.
`Config` `toConfig()` Converts this object to a `Config` instance, enabling you to use path expressions to find values in the object.
`java.util.Map<java.lang.String,java.lang.Object>` `unwrapped()` Recursively unwraps the object, returning a map from String to whatever plain Java values are unwrapped from the object's values.
`ConfigObject` `withFallback(ConfigMergeable other)` Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one.
`ConfigObject` `withOnlyKey(java.lang.String key)` Clone the object with only the given key (and its children) retained; all sibling keys are removed.
`ConfigObject` `withOrigin(ConfigOrigin origin)` Returns a `ConfigValue` based on this one, but with the given origin.
`ConfigObject` `withoutKey(java.lang.String key)` Clone the object with the given key removed.
`ConfigObject` `withValue(java.lang.String key, ConfigValue value)` Returns a `ConfigObject` based on this one, but with the given key set to the given value.

### Methods inherited from interface com.typesafe.config.ConfigValue

`atKey, atPath, origin, render, render, valueType`

### Methods inherited from interface java.util.Map

`clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, getOrDefault, hashCode, isEmpty, keySet, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size, values`

### Method Detail

#### toConfig

    Config toConfig()

Converts this object to a `Config` instance, enabling you to use path expressions to find values in the object. This is a constant-time operation (it is not proportional to the size of the object).

Returns:
  a `Config` with this object as its root

#### unwrapped

    java.util.Map<java.lang.String,java.lang.Object> unwrapped()

Recursively unwraps the object, returning a map from String to whatever plain Java values are unwrapped from the object's values.

Specified by:
  `unwrapped` in interface `ConfigValue`
Returns:
  a `Map` containing plain Java objects

#### withFallback

    ConfigObject withFallback(ConfigMergeable other)

Description copied from interface: `ConfigMergeable`
Returns a new value computed by merging this value with another, with keys in this value "winning" over the other one.

This associative operation may be used to combine configurations from multiple sources (such as multiple configuration files).

The semantics of merging are described in the spec for HOCON. Merging typically occurs when either the same object is created twice in the same file, or two config files are both loaded. For example:

      foo = { a: 42 }
      foo = { b: 43 }

Here, the two objects are merged as if you had written:

      foo = { a: 42, b: 43 }

Only `ConfigObject` and `Config` instances do anything in this method (they need to merge the fallback keys into themselves). All other values just return the original value, since they automatically override any fallback. This means that objects do not merge "across" non-objects; if you write `object.withFallback(nonObject).withFallback(otherObject)`, then `otherObject` will simply be ignored. This is an intentional part of how merging works, because non-objects such as strings and integers replace (rather than merging with) any prior value:

     foo = { a: 42 }
     foo = 10

Here, the number 10 "wins" and the value of `foo` would be simply 10. Again, for details see the spec.

Specified by:
  `withFallback` in interface `ConfigMergeable`
Specified by:
  `withFallback` in interface `ConfigValue`
Parameters:
  `other` - an object whose keys should be used as fallbacks, if the keys are not present in this one
Returns:
  a new object (or the original one, if the fallback doesn't get used)

#### get

    ConfigValue get(java.lang.Object key)

Gets a `ConfigValue` at the given key, or returns null if there is no value. The returned `ConfigValue` may have `ConfigValueType.NULL` or any other type, and the passed-in key must be a key in this object (rather than a path expression).

Specified by:
  `get` in interface `java.util.Map<java.lang.String,ConfigValue>`
Parameters:
  `key` - key to look up
Returns:
  the value at the key or null if none

#### withOnlyKey

    ConfigObject withOnlyKey(java.lang.String key)

Clone the object with only the given key (and its children) retained; all sibling keys are removed.

Parameters:
  `key` - key to keep
Returns:
  a copy of the object minus all keys except the one specified

#### withoutKey

    ConfigObject withoutKey(java.lang.String key)

Clone the object with the given key removed.

Parameters:
  `key` - key to remove
Returns:
  a copy of the object minus the specified key

#### withValue

    ConfigObject withValue(java.lang.String key,
                           ConfigValue value)

Returns a `ConfigObject` based on this one, but with the given key set to the given value. Does not modify this instance (since it's immutable). If the key already has a value, that value is replaced. To remove a value, use `withoutKey(String)`.

Parameters:
  `key` - key to add
  `value` - value at the new key
Returns:
  the new instance with the new map entry

#### withOrigin

    ConfigObject withOrigin(ConfigOrigin origin)

Description copied from interface: `ConfigValue`
Returns a `ConfigValue` based on this one, but with the given origin. This is useful when you are parsing a new format of file or setting comments for a single ConfigValue.

Specified by:
  `withOrigin` in interface `ConfigValue`
Parameters:
  `origin` - the origin set on the returned value
Returns:
  the new ConfigValue with the given origin